// wlԁxt@CovO

#include <stdio.h>
#include <stdlib.h>

#include "d88.h"

static unsigned char dir[0x300];				// Directory (256byte x 3sector)
static unsigned char buff[0x100*16*80];			// 256byte x 16sector x 80track
char fname[FILENAME_MAX];						// ؂ot@C

D88 disk;
FILE *fp;

bool fcut(char *_fname, int _trk, int _C, int _H, int _R, int _N, int _offset, int _size)
{

	if (!disk.ReadDATA(_trk, _C, _H, _R, _N, buff, _size+_offset)) return false;
//	printf ("cutting ... %s\n",_fname);
	fp = fopen(_fname,"wb");
	fwrite(buff + _offset, 1, _size, fp);
	fclose(fp);
	return true;
}

int main(int argc, char *argv[])
{
	int fn,trk,sec,size,addr;
	unsigned char *ent = dir;

	if (argc != 2) {
		// IvVw肪ȂƂ
		fprintf(stderr, "Usage: %s [d88file]\n",argv[0]);
		return 1;
	}

	// t@CJG[ɂȂ
	if (!disk.SetFile(argv[1])) {
		fprintf(stderr, "t@CI[vł܂\n");
		return 1;
	}

	int numdisk = disk.GetNumDisk();	// fBXNC[W

	disk.SelectDisk(0);
	disk.SetRecordRange(0x01,0x10);
	// hCo؂o
	fcut("DRIVER", 0x01, 0x00, 0x01, 0x01, 0x01, 0x0000, 0xc00);
	fcut("WRKTBL", 0x01, 0x00, 0x01, 0x0e, 0x01, 0x0000, 0x200);
//	fcut("INTR",   0x01, 0x00, 0x01, 0x10, 0x01, 0x0000, 0x100);
	fcut("VOICE",  0x02, 0x01, 0x00, 0x01, 0x01, 0x0000, 0x800);

	// fBNg̓ǂݍ
	disk.ReadDATA(0x00, 0x00, 0x00, 0x0d, 0x01, dir, 0x300);

	for (fn=0; fn < sizeof(dir)/8; fn++)
	{
		ent = &dir[fn*8];
		if (*ent==0xff) continue;			// Gg

		trk = *(ent+1);
		sec = *(ent+2);
		size = *(ent+3)*0x100;
		addr = *(ent+4)*0x100+*(ent+5);

		printf("%03d TRK=%02x SEC=%02x SIZE=%04x ADDR=%04x\n", fn, trk, sec, size, addr);
		sprintf(fname,"%03d",fn);
		fcut(fname, trk, trk>>1, trk&1, sec, 1, 0, size);
	}
	return 0;
}
